# ifndef lint
static char sccsid[] = "@(#)grk.c	5.4 (NTUA) 11/13/85";
# endif not lint

/*
 * grk
 */

# include	<stdio.h>
# include	<signal.h>
# include	<sys/types.h>
# include	<sys/stat.h>
# ifdef		BSD
#     include	<sys/ioctl.h>
#     include	<sgtty.h>
# else
#     include	<termio.h>
# endif
# include	<sys/time.h>
# include	<sys/file.h>

# define	_TYPES

# include	"grk.h"

#ifdef HPUX
#include	<sys/bsdtty.h>
#include	<sys/termio.h>
#endif
char               *getenv ();
char               *shell;
char               *progname;
int                 master;
int                 slave;
int                 child;
int                 subchild;
int                 finish ();
int                 wake_up_shell ();

int                 debug = 0;
int                 map_crlf = 1;
FILE               *debugfp = NULL;
char               *debugf = "/dev/tty";

# ifdef		BSD
struct sgttyb       old_term;
struct tchars       tc;
struct ltchars      lc;
struct winsize      win;
int                 lb;
int                 l;

# else
struct termio       old_term;

# endif

char                tty_line[25];	/* "/dev/tty00" */
char                tty_name[25];	/* the name of the slave --mt */
char               *args[1024];
int                 arg_cnt = 0;
int                 do_search_path = FALSE;
int                 utmp_fd = -1;

main(argc, argv)
int     argc;
char  **argv;

{

	char               *getenv ();
	char               *strcat (), *getenv ();;


	/* set a utmp entry */
	utmp_open ();			/* open it now, as long as you can */
# ifdef BSD
	(void) setegid (getgid ());	/* back to normal --mt */
	(void) seteuid (getuid ());	/* do not need anymore privileges */
# endif

	if (get_args (argc, argv)) {
		utmp_reset ();
		exit (-1);
	}
	set_term ();
	getmaster ();
	raw ();
	/* put a note so remote users know our 8 bit tty */
	utmp_set (tty_name, getenv ("USER"), "grk-8 bit");

	(void) signal (SIGCHLD, finish);
	(void) signal (SIGTERM, finish);
	(void) signal (SIGHUP, finish);
	(void) signal (SIGALRM, finish);
	child = fork ();
	if (child < 0) {
		perror ("fork");
		done ();
	}
	if (child == 0) {
		/* close utmp, just in case ....  --mt */
		(void) close (utmp_fd);
		utmp_fd = -1;

		subchild = child = fork ();
		if (child < 0) {
			perror ("fork");
			fail ();
		}
		if (!child)
			doshell ();
		else {
			signal (SIGCONT, wake_up_shell);
			getslave (O_RDONLY);
			dooutput ();
		}
	}
	getslave (O_RDONLY);
#ifdef TIOCGWINSZ
	setup_winch ();
#else
	tty_line[5] = 't';	/* "/dev/_" */
	slave = open (tty_line, O_RDWR);
	tty_line[5] = 'p';	/* "/dev/_" */
#endif
	doinput ();

	/* NOTREACHED */
}

# include	<sys/wait.h>
# include	<sys/resource.h>

finish()
{
	union wait status;
	register int pid;
	register int die = 0;

	Debug(fprintf(debugfp,"%d finishing \n",getpid()));

	while ((pid = wait3(&status, WNOHANG, (struct rusage *) 0)) > 0)
		if (pid == child)
			die = TRUE;
	if (die)
		done();
}

doshell()
{
	int     t,pgrp;

	if (debug && (debugfp != NULL))
		(void)fclose(debugfp);

#ifdef 	BSD
	t = open("/dev/tty", O_RDWR);
	if (t >= 0)
	{
		(void) ioctl(t, TIOCNOTTY, (char *) 0);
		(void) close(t);
	}
#else
	(void) close(0);
	(void) close(1);
	(void) close(2);
#endif
	getslave(O_RDWR);   /* opening any tty we get our controlling terminal */
	init_slave();
	(void) close(master);
	(void) dup2(slave, 0);
	(void) dup2(slave, 1);
	(void) dup2(slave, 2);
	(void) close(slave);

	if (do_search_path)
		execvp(shell, args);
	else
		execv(shell, args);
	perror(shell);
	fail();
}

raw()
{
#ifdef	BSD
	struct sgttyb sbuf;
#ifdef	ZTEST
	int     lmode;

# ifdef SUNOS
	lmode = lb | LPASS8;
# else
	lmode = lb | LPASS8 + LLITOUT;
# endif SUNOS
	(void) ioctl(0, TIOCLSET, (char *) &lmode);
#endif ZTEST
	sbuf = old_term;
	sbuf.sg_flags &= ~ECHO;
	sbuf.sg_flags |= RAW;
	sbuf.sg_flags |= CRMOD;
	(void) ioctl(0, TIOCSETP, (char *) &sbuf);
#else
	struct termio sbuf;

	sbuf = old_term;
	sbuf.c_iflag &= ~ICRNL;
	sbuf.c_lflag &= ~(ECHO | ICANON);
	sbuf.c_oflag &= ~(TAB3 | ONLCR);
	sbuf.c_cflag |= CS8;
	sbuf.c_cc[VINTR] = sbuf.c_cc[VQUIT] = 0377;
	(void) ioctl(0, TCSETA, (char *) &sbuf);
#endif BSD
}

noraw()
{
#ifdef	BSD
	/* set terminal parapeters (getty)*/
	(void) ioctl(0, TIOCSETP, (char *) &old_term);

	/* restore the rest of the stuff too -- mt */
	/* set special characters */
	(void) ioctl(0, TIOCSETC, (char *) &tc);
	/* set line disipline */
	(void) ioctl(0, TIOCSETD, (char *) &l);
	/* set local special chars  */
	(void) ioctl(0, TIOCSLTC, (char *) &lc);
	/* set local modes */
	(void) ioctl(0, TIOCLSET, (char *) &lb);

	/* do not restore window characteristics. They are right !-- mt */
	/* (void) ioctl(0, TIOCSWINSZ, (char *) &win); */
#else
	(void) ioctl(0, TCSETA, (char *) &old_term);
#endif
}

fail()
{

	(void) kill(0, SIGTERM);
	done();
}

done()
{
	(void) close(slave);    /* otherwise the dooutput hungs ! --mt */
	if (subchild){
		(void) close(master);
	}else{
		noraw();
		utmp_reset();						/* clean up utmp entry --mt */
	}
	exit(0);
}

getmaster()
{
	char   *pty, *bank, *cp;
	struct stat stb;

# ifdef HPUX
	(void) strcpy(tty_line, "/dev/ptym/pty");
	pty = &tty_line[14];	       /* "/dev/ptym/ptyX_" */
# else
	(void) strcpy(tty_line, "/dev/pty");
	pty = &tty_line[9];	       /* "/dev/ptyX_" */
# endif
	for (bank = "pqrs"; *bank; bank++)
	{
# ifdef HPUX
		tty_line[13] = *bank;   /* "/dev/pty_" */
# else
		tty_line[8] = *bank;   /* "/dev/pty_" */
# endif
		*pty = '0';
		if (stat(tty_line, &stb) < 0)
			break;
		for (cp = "0123456789abcde"; *cp; cp++)
		{
			*pty = *cp;
			master = open(tty_line, O_RDWR);
			if (master >= 0)
			{
				int     ok;
				/* verify slave side is usable */
# ifdef HPUX
				char   *tp = &tty_line[10];	/* "/dev/ptym/_" */

				*tp = 't';
				(void) strcpy( tty_name, tty_line);   /* save the name --mt */
# else 
				char   *tp = &tty_line[5];	/* "/dev/_" */

				*tp = 't';
				(void) strcpy( tty_name, tty_line);   /* save the name --mt */
# endif
				ok = access(tty_line, R_OK | W_OK) == 0;
				*tp = 'p';
				if (ok)
				{
# ifdef		BSD
					/* get terminal parameters (getty)*/
					(void) ioctl(0, TIOCGETP, (char *) &old_term);
					/* get special characters */
					(void) ioctl(0, TIOCGETC, (char *) &tc);
					/* get line disipline */
					(void) ioctl(0, TIOCGETD, (char *) &l);
					/* get local special chars  */
					(void) ioctl(0, TIOCGLTC, (char *) &lc);
					/* get local modes */
					(void) ioctl(0, TIOCLGET, (char *) &lb);
					/* get window characteristics */
					(void) ioctl(0, TIOCGWINSZ, (char *) &win);
# else
					(void) ioctl(0, TCGETA, (char *) &old_term);
# endif
					return;
				}
				(void) close(master);
			} else {
# ifdef HPUX
				fprintf(stderr, "`%s': failed\n", tty_line);
				perror(tty_line);
# endif
			}
		}
	}
	fprintf(stderr, "Out of pty's\n");
	fail();
}

getslave(mode)
	int mode;
{
	tty_line[5] = 't';	       /* "/dev/_" */
	slave = open(tty_line, mode);
	tty_line[5] = 'p';	       /* "/dev/_" */
	if (slave < 0)
	{
		perror(tty_line);
		fail();
	}
}


init_slave()
{
#ifdef	ZTEST
	struct sgttyb       sbuf;
	int                 lmode;
#endif

#ifdef		BSD
#ifdef	ZTEST
#ifndef SUNOS
	sbuf = old_term;
	sbuf.sg_flags |= RAW;
	sbuf.sg_flags |= CRMOD;
	(void) ioctl (slave, TIOCSETP, (char *) &sbuf);
	lmode = lb | LLITOUT | LPASS8;
# else  SUNOS
	(void) ioctl (slave, TIOCSETP, (char *) &old_term);
	lmode = lb | LPASS8;
# endif SUNOS
	(void) ioctl (slave, TIOCLSET, (char *) &lmode);
#else	ZTEST
	(void) ioctl (slave, TIOCSETP, (char *) &old_term);
	(void) ioctl (slave, TIOCLSET, (char *) &lb);
#endif  ZTEST
	(void) ioctl (slave, TIOCSETC, (char *) &tc);
	(void) ioctl (slave, TIOCSLTC, (char *) &lc);
	(void) ioctl (slave, TIOCSETD, (char *) &l);
	(void) ioctl (slave, TIOCSWINSZ, (char *) &win);
#else
	(void) ioctl (slave, TCSETA, (char *) &old_term);
#endif
}


/*
 * process some command line arguments
 * --mt
 */

get_args (ac, av)
	char              **av;
	int                 ac;
{
	extern int          optind;
	extern char        *optarg;
	int                 c, argc;
	FILE               *fopen ();
	char              **argv;

	/* set default options */
	progname = av[0];

	while ((c = getopt (ac, av, "do:c")) != EOF)
		switch (c) {
		    case 'c':
			map_crlf = 0;
			break;

		    case 'd':
			debug++;
			break;

		    case 'o':
			debugf = optarg;
			break;

		    default:
			return usage (NULL);
		}
	if (debug && ((debugfp = fopen (debugf, "w")) == NULL)) {
		perror ("opening debug file");
		fprintf (stderr, "sorry no debugging\n");
		debug = 0;
	}
	argc = ac - optind;
	argv = &av[optind];

	if (!(shell = getenv ("SHELL")))
		shell = "/bin/sh";

	if (argc == 0) {
		args[arg_cnt++] = shell;
		args[arg_cnt++] = "-i";
	} else {
		shell = *argv;

		if (!((shell[0] == '/') ||
		      (shell[0] == '.' && shell[1] == '/') ||
		      (shell[1] == '.' && shell[1] == '.' && shell[2] == '/')))
			do_search_path = TRUE;
		while (argc--)
			args[arg_cnt++] = *argv++;
	}
	args[arg_cnt] = 0;

	return 0;
}


usage (mesg)
	char               *mesg;
{
	if (mesg)
		fprintf (stderr, "Bad option val %s\n", mesg);
	fprintf (stderr,
	   "%s  [-d] [-o dbgfile] [-c] [command [args ...] ]\n", progname);
	fprintf (stderr,
	   "\t-d     : to print debugging info            [off]\n");
	fprintf (stderr,
	   "\t-o     : where to print debug messages      [/dev/tty]\n");
	fprintf (stderr,
	   "\t-c     : do not map LF to CR LF             [map]\n");
	fprintf (stderr,
	   "\tcommand: program to run                     [$SHELL,/bin/csh]\n");
	return (-1);
}

wake_up_shell ()
{
	kill (subchild, SIGCONT);
}

/*
 * If the current window changes, notify the shell process
 * (and everything that has the same controlling tty)
 * --mt
 */

#ifdef TIOCGWINSZ
static struct winsize curr_win;

setup_winch ()
{
	int                 win_changed ();

	tty_line[5] = 't';	/* "/dev/_" */
	slave = open (tty_line, O_RDWR);
	tty_line[5] = 'p';	/* "/dev/_" */

	(void) ioctl (0, TIOCGWINSZ, (char *) &curr_win);
	signal (SIGWINCH, win_changed);
}

/*
 * this routine is called when the tty window has changed
 */
win_changed ()
{
	struct winsize      win;

	/* get window characteristics */

	if (ioctl (0, TIOCGWINSZ, &win) == 0) {
		/* bcmp(&win, &curr_win, sizeof (win))) { */
		curr_win = win;
		Debug ((fprintf (debugfp, "window changed\n"), fflush (debugfp)));
		/* set the window size ! */
		(void) ioctl (slave, TIOCSWINSZ, &win);
	}
	signal (SIGWINCH, win_changed);
}

#endif
